/*                                */
/* x777   -------------   crack.c */
/*                                */

#include "graphics.h"
#include "games.h"

static void  fallDownBlocks (), flushBlocks (), flushCheckedBlocks ();
static void  checkCrack (), crackBlocks (), clearSubBoard ();
static void  starComes (), starHasCome ();


int  selected_column;
static int  sc_x, sc_y;


void  DropItem ()
{
   if (! gameover_flag)
    {
      if (((!star_comes) && (! CanItemMove (0, MOVE_DOWN, drop_i.rot)))
	  || ((star_comes) && (! CanStarMove (0, MOVE_DOWN))))
	{
	  chain_step = 0;
	  fallDownBlocks ();
	  if (star_comes)
	    starComes ();
	  do {
	    if (star_comes) 
	      starHasCome();
	    do
	      {
		chain_step++;
		tmp_blocks = 0;
		checkCrack ();
		addScore (sc_x, sc_y);
		fallDownBlocks ();
	      } while (tmp_blocks != 0);
	  } while (star_comes);
	  if (chain_step > 0)
	    {
	      printScore ();
	      printLevel ();
	    }
	  makeNext ();
	  printItem ();
	}
      else
	moveItem (0, MOVE_DOWN);
      
      startTimer ();
    }
}


static void  checkCrack ()
{
  int  k, x, y, three, del_flag = FALSE;
  static int  dir_x[4] = {1, 0, -1,  0};
  static int  dir_y[4] = {0, 1,  0, -1};

  clearSubBoard ();

  for (x = 1; x <= BOARD_WIDTH; x++)
    for (y = 0; y < BOARD_HEIGHT; y++)
      for (k = 0; k < 4; k++)
	if ((board[x][y].blk != EMPTY) && (board[x][y].blk != 7)
	    && (board[x][y].blk + board[x + dir_x[k]][y + dir_y[k]].blk == 7))
	  {
	    if (board[x + dir_x[k]][y + dir_y[k]].sub == EMPTY)
	      {
		board[x + dir_x[k]][y + dir_y[k]].sub = DELETE;
		sc_x = x; sc_y = y;
		del_flag = TRUE;
	      }
	  }
  for (x = 1; x <= BOARD_WIDTH; x++)
    for (y = 1; y < BOARD_HEIGHT; y++)
      for (k = 0; k < 2; k++)
	if (board[x][y].blk == 7)
	  {
	    three = board[x - dir_x[k]][y - dir_y[k]].blk + board[x][y].blk * 10
	            + board[x + dir_x[k]][y + dir_y[k]].blk * 100;
	    if (board[x][y].blk * 111 == three)
	      {
		del_flag = TRUE;
		board[x - dir_x[k]][y - dir_y[k]].sub = DELETE;
		board[x][y].sub = DELETE;
		board[x + dir_x[k]][y + dir_y[k]].sub = DELETE;
		sc_x = x; sc_y = y;
	      }
	  }
  if (del_flag == TRUE)
    {
      flushCheckedBlocks ();
      flushBlocks ();
      crackBlocks ();
    }
  else  usleep (50000);
}


static void  clearSubBoard ()
{
  int  x, y;

  for (y = 0; y < BOARD_HEIGHT; y++)
    for (x = 1; x <= BOARD_WIDTH; x++)
      {
	board[x][y].sub = EMPTY;
      }
}  


static void  crackBlocks ()
{
  int  x, y;

  for (x = 1; x <= BOARD_WIDTH; x++)
    for (y = 0; y < BOARD_HEIGHT; y++)
      {
	if (board[x][y].sub == DELETE)
	  {
	    delete_1_block (x, y);
	    board[x][y].blk = EMPTY;
	    board[x][y].sub = EMPTY;
	    tmp_blocks++;
	  }
      }
}


static void  fallDownBlocks ()
{
  int  x, y, wy = BOARD_HEIGHT - 1, wy1, wy2;
  int  lines[BOARD_HEIGHT + 2], sub_lines[BOARD_HEIGHT + 2];

  for (x = 1; x <= BOARD_WIDTH; x++)
    {
      while (wy != -1) 
	{
	  if (board[x][wy].blk == EMPTY)
	    {
	      wy1 = wy;
	      while ((wy != -1) && (board[x][wy].blk == EMPTY)) wy--;
	      if (wy != -1)
		{
		  wy2 = wy -1;
		  for (y = 0; y <= wy2 + 1; y++)
		    {
		      lines[y] = board[x][y].blk;
		      sub_lines[y] = board[x][y].sub;
		      delete_1_block (x, y);
		      board[x][y].blk = EMPTY;
		      board[x][y].sub = EMPTY;
		    }
		  for (y = wy1 - wy2 - 1; y <= wy1; y++)
		    {
		      board[x][y].blk = lines[y - wy1 + wy2 + 1];
		      board[x][y].sub = sub_lines[y - wy1 + wy2 + 1];
		      if (board[x][y].blk != EMPTY)
			printBlock (x, y, board[x][y].blk);
		    }
		  wy = wy1;
		}
	    }
	  else wy--;
	}
      wy = BOARD_HEIGHT - 1;
    }
}


static void  flushCheckedBlocks ()
{
  int  x, y, k;
  
  for (k = 0; k < 4; k++)
    {
      for (x = 1; x <= BOARD_WIDTH; x++)
	for (y = 0; y <= BOARD_HEIGHT - 1; y++)
	  {
	    if (board[x][y].sub == DELETE)
	      delete_1_block (x, y); 
	  }
      XSync (XtDisplay (board_w), FALSE);
      usleep (28000);
      for (x = 1; x <= BOARD_WIDTH; x++)
	for (y = 0; y <= BOARD_HEIGHT -1; y++)
	  {
	    if (board[x][y].sub == DELETE)
	      printBlock (x, y, board[x][y].blk);
	  }
      XSync (XtDisplay (board_w), FALSE);
      usleep (28000);
    }
}


static void  flushBlocks ()
{
  int  x, y, i;
  
  for (i = 0; i < CRUSH_ANIME_FRAMES; i++)
    {
      for (x = 1; x <= BOARD_WIDTH; x++)
	for (y = 0; y <= BOARD_HEIGHT - 1; y++)
	  {
	    if (board[x][y].sub == DELETE)  crushAnimate (x, y, i);
	  }
      XSync (XtDisplay (board_w), FALSE);
      usleep (23000);
      for (x = 1; x <= BOARD_WIDTH; x++)
	for (y = 0; y <= BOARD_HEIGHT - 1; y++)
	  {
	    if (board[x][y].sub == DELETE)  crushAnimate (x, y, i);
	  }
      XSync (XtDisplay (board_w), FALSE);
      usleep (23000);
    }
}


static void  starComes ()
{
  selected_column = drop_i.x;
  board[drop_i.x][drop_i.y].blk = STAR;
}

static void  starHasCome ()
{
  if (board[selected_column][BOARD_HEIGHT - 1].blk != EMPTY)
    {
      board[selected_column][BOARD_HEIGHT - 1].sub = DELETE;
      sc_x = selected_column; sc_y = BOARD_HEIGHT - 1;
    }
  else 
    star_comes = FALSE;

  flushBlocks ();
  crackBlocks ();
  XSync (XtDisplay (board_w), FALSE);
  usleep (200000);

  fallDownBlocks ();
  addScore (sc_x, sc_y);
}
